<?php
/*=================================================================
#	Copyright (c) 2002 by [ x-dev.de/x-gfx.de ]
#	Guestbook-Script by Robert Klikics [rob@x-dev.de]
#==================================================================
#	Website: 	http://www.x-gfx.de [english/german]      
#	Requires:	PHP 4.1.x ++
#	License: 	GPL/Free
#	[ Comments/Additions are welcome! ]
#==================================================================
#	Help: Please read the doc-files for further informations!
#==================================================================
#	File: class.csv.php [data-handling]
#===================================================================*/  


class csv {
	
	var $_output = array();
	
		
	/* save a posting to csv/posts.txt */
	function _save_posting($mail, $name, $page, $post) {
		
		$fp  = fopen("csv/posts.txt", "a");
			
		// del \n 's, ^ 's and \r 's
		$post = nl2br($post);
		$post = preg_replace("/\n|\r/is", ""  , $post);
		$post = preg_replace("//is", "&sup2;", $post);
		
		// format the string to write 
		$str = time() . "" .$mail . "" .$name . "" . $page . "" . $post . "\n";
		
		// write csv
		flock($fp, LOCK_EX);
		
		$write = fputs($fp, $str);
		
		flock($fp, LOCK_UN);
		fclose($fp);
		
		if($write) 	return true;
		else		return false;
	}
	
	/* get posts */
	function _get_posts() {
		
		global $cfg;
		$cnt = 0;
		
		// get max. line-length
		$line_len = $cfg['max_email'] + $cfg['max_name'] + $cfg['max_hp_url'] + $cfg['max_posting'] + 10;
		
		// start at?
		if( empty($_GET['s']) ) 			$start = 0;
		else						$start = $_GET['s'];
		
		// to?
		$to = $start + $cfg['posts_per_page'];
	
		// get file
		$line = array_reverse( file("csv/posts.txt") );
				
		// get posts
		for($i = $start; $i < $to; $i++) {
			
			$row = explode("", $line[$i]);
			
			$this->_output[$cnt]['time'] = $row['0'];
			$this->_output[$cnt]['mail'] = $row['1'];
			$this->_output[$cnt]['name'] = $row['2'];
			$this->_output[$cnt]['page'] = $row['3'];
			$this->_output[$cnt]['post'] = $row['4'];
			
			$cnt++;
			
			// is this the end? ;)
			if($i == count($line) -1)	break;

		}
				
		return $this->_output;
		
	}	
	
	/* get total count of posts */
	function _get_total_count() {
		
		return count( file("csv/posts.txt") );
	}
	
	/* delete a posting (admin) */
	function delete($id) {
		
		$new_str = "";
		
		foreach( file("csv/posts.txt") as $line) {
			
			if( !preg_match("/^".$id."/", $line) )	$new_str .= $line;
			
		}
		
		// write csv
		$fp = fopen("csv/posts.txt","w");
		
		flock($fp, LOCK_EX);
		
		$ok = fwrite($fp, $new_str);
		
		flock($fp, LOCK_UN);
		fclose($fp);
		
		if($ok)		return true;
		else		return false;
	}
	
	/* save an edited msg (admin) */
	function save_edited_msg($id) {
		
		$new = "";
		
		// del \n 's, ^ 's and \r 's
		$post = nl2br($_POST['post']);
		$post = preg_replace("/\n|\r/is", ""  , $post);
		$post = preg_replace("//is", "&sup2;", $post);
		
		foreach( file("csv/posts.txt") as $line) {
			
			// replace edited line
			if( preg_match("/^".$id."/i", $line) )	$new .= $id . "" .$_POST['mail'] . "" .$_POST['name'] . "" . $_POST['page'] . "" . $post . "\n";
			else					$new .= $line;
		}
		
		// write csv
		$fp = fopen("csv/posts.txt","w");
		
		flock($fp, LOCK_EX);
		
		$ok = fwrite($fp, $new);
		
		flock($fp, LOCK_UN);
		fclose($fp);
		
		if($ok)		return true;
		else		return false;
	}
	
	/* save the badwords (admin) */
	function save_badwords() {
		
		$fp = fopen("csv/badwords.txt","w");
		$ok = fwrite($fp, $_POST['badwords'], strlen($_POST['badwords']) );
		fclose($fp);
		
		if($ok)		return true;
		else		return false;
	}
	
	/* add a smilie to the list (admin) */
	function add_smilie() {
		
		$str = $_POST['code'] . "###" . $_POST['img'] . "\n";
		
		$fp  = fopen("csv/smilies.txt", "a");
		$ok  = fputs($fp, $str);
		
		fclose($fp);
		
		if($ok) 	return true;
		else		return false;
	}
	
	/* delete a smilie from the list (admin) */
	function del_smilie() {
		
		$new_str = "";
		
		foreach( file("csv/smilies.txt") as $line) {
			
			$temp = trim( quotemeta($_GET['img']) );
			if( !preg_match("/".$temp."/", $line) )	$new_str .= $line;
		}
		
		// write csv
		$fp = fopen("csv/smilies.txt","w");		
		fwrite($fp, $new_str);
		fclose($fp);
		
		return true;
	}
}
?>