<?php
/*=================================================================
#	Copyright (c) 2002 by [ x-dev.de/x-gfx.de ]
#	Guestbook-Script by Robert Klikics [rob@x-dev.de]
#==================================================================
#	Website: 	http://www.x-gfx.de [english/german]      
#	Requires:	PHP 4.1.x ++
#	License: 	GPL/Free
#	[ Comments/Additions are welcome! ]
#==================================================================
#	Help: Please read the doc-files for further informations!
#==================================================================
#	File: class.xgb.php [main-class]
#===================================================================*/ 

class xGB {
	
	/* var's */
	
	var $html;	// html-output string	
	
	
	/* add's any html-tag(s) to the output-string */
	function show($tags, $br = false) {
		
   		if($br)		$this->html .= $tags . "<br>" . "\n";	// with <br>
   		else		$this->html .= $tags . "\n";		// no <br>
   	}
	
	/* print sign-form */
	function sign_form() {
		
		global $cfg;
		
		$this->show("<span id='menu'>");
		
		// html-status
		if($cfg['html'] == "on")	$this->show("[ HTML ".ON." ]");
		else				$this->show("[ HTML ".OFF." ]");
		
		$this->show(" ".SEPERATOR." ");
		
		// bb-code status
		if($cfg['bb_codes'] == "on")	$this->show("[ <a href='javascript:bb()' title='BB-Codes'>BB-Codes</a> ".ON." ]");
		else				$this->show("[ BB-Codes ".OFF." ]");
		
		// smilie-link
		$this->show(" ".SEPERATOR." [ <a href='javascript:smilies()' title='".SMILIES."'>".SMILIES."</a> ]",true);
		
		$this->show("</span>");
		
		// form
		$this->show("<br>\n<form action='".$_SERVER['PHP_SELF']."' method='post' name='newsarea'>");
		$this->show("<input type='hidden' name='act' value='save_posting'>",true);
		$this->show(ENTER_NAME."<br>\n<input type='text' name='name' maxlength='".$cfg['max_name']."' id='sign_input'><br>",true);
		$this->show(ENTER_EMAIL."<br>\n<input type='text' name='mail' maxlength='".$cfg['max_email']."' id='sign_input'><br>",true);
		$this->show(ENTER_HOMEPAGE."<br>\n<input type='text' value='http://' name='page' maxlength='".$cfg['max_hp_url']."' id='sign_input'><br>",true);
		$this->show(ENTER_MESSAGE."<br>\n<textarea id='sign_textarea' name='post'></textarea>",true);
		$this->show("<br>\n<input title='".SUBMIT."' type='submit' value='".SUBMIT."' id='button'>");
		$this->show("&nbsp;<input title='".CHECK_LEN."' type='button' value='".CHECK_LEN."' id='button' onClick='javascript:CheckLength(".$cfg['max_posting'].")'>");
		$this->show("</form>");
		
		// 
		$this->show( $this->copyright() );
		
		return $this->html;
	}
	
	/* validate a new posting */
	function validate() {
		
		global $cfg;
		$error = "";
		
		// error's?
		if( empty($_POST['name']) )							$error .= "<li>".ERR_NAME;
		
		if( !preg_match("/^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,4}|museum$/i", $_POST['mail']) ) {
			
			$error .= "<li>".ERR_MAIL;
		}
		
		if( !empty( $_POST['page']) && !preg_match("/^http:\/\//i", $_POST['page']) )	$error .= "<li>".ERR_HP;
		if( strlen($_POST['post']) < 10)						$error .= "<li>".ERR_POST;
		if( strlen($_POST['post']) > $cfg['max_posting'] )				$error .= "<li>".ERR_POSTLEN;
		
		// if we have a homepage-string, but only 'http://', let's delete it
		if( preg_match("/^http:\/\/$/i", $_POST['page']) )				$_POST['page'] = "";
		
		// print error, if we really have one ;)
		if( $error != "")								return	"<div align='center' id='error'><p align='center'><font size='2'><b>".ERROR."</b></font>\n<ul>".$error."\n<p>\n<li><a href='javascript:history.back()' title='".BACK."'>".BACK."</ul></div>";
		
		// parse & save it
		if( csv::_save_posting($_POST['mail'], htmlentities($_POST['name'], ENT_QUOTES), htmlentities($_POST['page'], ENT_QUOTES), $_POST['post']) ) {
			
			// ok-msg
			return "\n<meta http-equiv=\"refresh\" content=\"3; URL=".$_SERVER['PHP_SELF']."?s=0\">\n<div align='center' id='ref'><p align='center'>".POST_SAVED."<p align='center'><a href='".$_SERVER['PHP_SELF']."?s=0'>".REFERER."</div>";	
		
		} else {	
			
			// error-msg
			return "Can't save to CSV-File (chmod?). Sorry!";
		}
	}
	
	/* parse a posting */
	function parse($post) {
		
		global $cfg;
		
		// html-tags
		if($cfg['html'] == "off")	$post = strip_tags($post, "<br>");
		else				$post = strip_tags($post, $cfg['allowed_tags']."<br>");
		
		// bb-codes
		if($cfg['bb_codes'] == "on") {
		
			$post = preg_replace( "#\[b\](.+?)\[/b\]#is", "<b>\\1</b>", $post);	// [b]
			$post = preg_replace( "#\[i\](.+?)\[/i\]#is", "<i>\\1</i>", $post);	// [i]
			$post = preg_replace( "#\[u\](.+?)\[/u\]#is", "<u>\\1</u>", $post);	// [u]
			
		}
		
		// auto-parse url's
		$pat  = '#(^|[^\"=]{1})(http://|ftp://|mailto:|news:|https://)([^\s<>]+)([\s\n<>]|$)#smi';
  		$post = preg_replace($pat, "\\1<a href=\"\\2\\3\" target=\"_blank\">\\2\\3</a>\\4", $post);
		
		// replace badwords
		$post = $this->badwords($post);
		
		// del backslashes
		$post = stripslashes($post);
		
		return $this->_parse_smilies($post);
	}
	
	/* parse smilies */
	function _parse_smilies($post) {
		
		// get them
		$smilies = file("csv/smilies.txt");
		
		// replace the, in post
		foreach($smilies as $row) {
			
			$temp = explode("###", $row);
			$post = preg_replace("/".quotemeta($temp['0'])."/i", "<img src='img/".$temp['1']."' alt='".$temp['0']."'>", $post);	
		}
		
		return $post;
	}
	
	/* show all smilies (popup) */
	function show_smilies($_admin = false) {
		
		// read csv
		$lines = file("csv/smilies.txt");
		
		// table
		$this->show("<table width='100%' height='*' cellspacing='0' cellpadding='3' align='center'>");
		$this->show("<tr><td colspan='2' align='center' id='text_on_top'>".SMILIES."</td></tr>");
		if(!$_admin)	$this->show("<tr><td colspan='2' align='center' id='smilies_info'>".SMILIES_INFO."</td></tr>");
		
		foreach($lines as $row) {
			
			$temp = explode("###", $row);
			
			// admin-links
			if($_admin)	$link = "[ <a href='".$_SERVER['PHP_SELF']."?act=admin&do=delete_smilie&img=".$temp['1']."' title='delete this one'>del</a> ]";
			else		$link = "";
			
			$this->show("<tr>\n\t<td id='left_col' align='center'>".$temp['0']."</td>");
			$this->show("\t<td id='right_col' align='center'><a href='javascript:add_smilie(\"".$temp['0']."\")'><img src='img/".$temp['1']."' border='0' alt='".ADD." ".$temp['0']."'></a> ".$link." </td>\n</tr>");
		}
		
		$this->show("</table>",true);
		if(!$_admin)	$this->show("[ <a href='javascript:self.close()' title='".CLOSE_WIN."'>".CLOSE_WIN."</a> ]");
		
		return $this->html;
	}
	
	/* parse badwords */
	function badwords($post) {
		
		// get them
		$fp    = fopen("csv/badwords.txt", "r");
		$words = fread($fp, filesize("csv/badwords.txt") );
		fclose($fp);
		clearstatcache();
		
		// replace them
		foreach( explode(",", $words) as $word) {
			
			$post = preg_replace("/$word/i", $word{0}.str_repeat( "*", strlen($word)-1 ), $post); 
		}
		
		return $post;
		
	}
	
	/* get posts */
	function get_posts() {
		
		global $cfg;
		$cnt = 0;
		
		// get data from csv
		$posts = csv::_get_posts();
		
		for($i = 0; $i < count($posts); $i ++) {
			
			/* format & print posting from/with the template */
			
			// is this a converted datestring from xGB v1.0 or a unix-timestamp?
			if( strlen($posts[$i]['time']) == 10 )	$time = date( $cfg['date_format'], $posts[$i]['time'] );
			else					$time = $posts[$i]['time'];
			
			$name = htmlentities( $posts[$i]['name'], ENT_QUOTES );
			$temp = explode("@", $posts[$i]['mail']);
			$mail = "javascript:contact(\"".$temp['0']."\",\"".$temp['1']."\");";
			$post = $this->parse($posts[$i]['post']);
			
			// hp
			if( empty($posts[$i]['page']) )		$page = "";
			else					$page = "<a href='".strip_tags($posts[$i]['page'])."' title='".strip_tags($posts[$i]['page'])."'>".HOMEPAGE."</a>";
			
			
			// show admin-options if we're logged in as admin
			if( admin::check() && $_GET['do'] == "edit_del" ) echo "<a href='".$_SERVER['PHP_SELF']."?act=admin&do=edit&id=".$posts[$i]['time']."'>Edit</a> ".SEPERATOR." <a href='javascript:delete_msg(".$posts[$i]['time'].")'>Delete</a>";
			
			// get template
			include("inc/template.inc.php");
		
			$cnt++;
		}
		
		echo "<br>\n" . $this->navi();
		echo "<br>\n" . $this->copyright();
		
		
		return $this->html;
	}
	
	/* copyright, please don't removet this - thank you in advance */
	function copyright() {
		
		global $cfg;
		return "<br>\n<p align='center'><span id='copyright'>[ powered by <a href='http://www.x-gfx.de' target='blank' title='Script by x-gfx.de'>xGB 2.0</a> ".SEPERATOR." &copy <a href='".$cfg['page_url']."' title='".$cfg['page_url']."' target='_blank'>".$cfg['page_name']."</a> ".SEPERATOR." <a href='".$_SERVER['PHP_SELF']."?act=admin' title='admin'>admin</a> ]</span>";
	}
	
	/* menu and total count of posts */
	function menu() {
		
		if( empty($_GET['act']) && empty($_POST['act']) )	  {
			
			$count = csv::_get_total_count();
			return "<p align='center'><span id='menu'>[ <a href='".$_SERVER['PHP_SELF']."?act=sign' title='".SIGN."'>".SIGN."</a> ".SEPERATOR." ".$count." ".TOTAL_POSTS." ]</span>\n<p>&nbsp;</p>\n";
				
		} elseif( $_GET['act'] == "sign" ) {	
			
			return "<p align='center'><span id='menu'>[ <a href='".$_SERVER['PHP_SELF']."' title='".MAIN_PAGE."'>".MAIN_PAGE."</a> ]</span>\n<p>&nbsp;</p>\n";
			
		} else {
			
			return "";
			
		}
	}
	
	/* navigation */
	function navi() {
	
		global $cfg;	
		$html = "";
		
		// admin-mode?
		if($_GET['act'] == "admin")	$cc = "&act=admin&do=edit_del";
		else				$cc = "";
		
		// get navi-var's
		$all = csv::_get_total_count();
		
		$next = $_GET['s'] + $cfg['posts_per_page'];
		$prev = $_GET['s'] - $cfg['posts_per_page'];
		
		if(!$_GET['s'])	$page = 1; 
		else 		$page = $_GET['s'] / $cfg['posts_per_page'] + 1;
		
		// print navi
		if( isset($_GET['s']) && $_GET['s'] != 0 )	$html .= "[  <a href='".$_SERVER['PHP_SELF']."?s=".$prev.$cc."' title='".PREV_PAGE."'>".ARROW_BACKWARDS."</a> ] ".SEPERATOR;
		
		$html .= " [ ".PAGE." ".$page." ] ";
		
		if($_GET['s'] + $cfg['posts_per_page'] < $all) 	$html .= SEPERATOR." [ <a href='".$_SERVER['PHP_SELF']."?s=".$next.$cc."' title='".NEXT_PAGE."'>".ARROW_FORWARD."</a> ]\n";
		
		return $html;
		
	}


}